﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace LedDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            /* 初始化jinhan comm库 */
            LedControl.JHCommInit();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int res;
            IntPtr hdl = IntPtr.Zero;
            IntPtr ptl = IntPtr.Zero;
            IntPtr pargs = IntPtr.Zero;
            
            /* 本例只为演示功能，更多接口请调用DllImport来获得，千万要注意C#参数和C Dll中的接口要一一对应，否则会找不到函数入口点或调用出错 */
            /* JHCommInit和JHCommDeinit接口可以放在应用程序的初始化和退出时分别调用，且必须调用，否则TCP和UDP不能正常通讯，本例中分别放在Form1_Load和Form1_FormClosed中调用 */

            /* 创建控制卡实例 */
            res = LedControl.JHCreateInst(ref hdl, 1);
            if (res != LedControl.JR_OK)
            {
                MessageBox.Show("创建控制卡实例失败， 错误代码：" + res);
                return;
            }

            /* 获得TCP的传输接口 */
            res = LedControl.JHCommGetTransportlayer(ref ptl, 0/* 0: tcp; 1: udp; 2: ether; 3:serial port; */);
            if (res != LedControl.JR_OK)
            {
                LedControl.JHDeleteInst(hdl);
                MessageBox.Show("获得传输层接口失败， 错误代码：" + res);
                return;
            }

            /* 获得通讯参数 */
            res = LedControl.JHCommGetNetArgStruct(ref pargs, "192.168.1.3", 30000, 5000);
            //res = LedControl.JHCommGetSerialportArgStruct(ref pargs, "COM1", 115200, 8, 0, 0, 5000);
            if (res != LedControl.JR_OK)
            {
                LedControl.JHDeleteInst(hdl);
                MessageBox.Show("获得传输层参数失败， 错误代码：" + res);
                return;
            }

            /* 为控制卡绑定传输层接口及通讯参数 */
            res = LedControl.JHMountTransportLayer(hdl, ptl, pargs);
            if (res != LedControl.JR_OK)
            {
                LedControl.JHCommReleaseArgStruct(pargs);
                LedControl.JHDeleteInst(hdl);
                MessageBox.Show("挂载传输层接口失败， 错误代码：" + res);
                return;
            }

            /* 释放通讯参数 */
            LedControl.JHCommReleaseArgStruct(pargs);

            string text = richTextBox1.Text.ToString();

            /* 调用屏幕操作中的DrawText接口来立即显示一段文本 */
            res = LedControl.JHDrawText(hdl, 0, 0, 32, 16, 0, text);
            if (res == LedControl.JR_OK)
            {
                MessageBox.Show("发送DrawText指令成功");
            }
            else
            {
                MessageBox.Show("发送DrawText指令失败， 错误代码：" + res);
            }

            /* 删除控制卡实例 */
            LedControl.JHDeleteInst(hdl);
        }
        
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            /* 清理jinhan comm库 */
            LedControl.JHCommDeinit();
        }
    }
}
