// AddBatch.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>

#define __USER_STATIC_LIBRARY
#include "..\\..\\include\\JHComm.h"


#pragma comment (lib, "..\\..\\lib\\Windows\\jinhancomm.lib")
#pragma comment (lib, "..\\..\\lib\\Windows\\jinhanzk.lib")

#define COMM_SERIALPORT  1


int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hdl;
	HANDLE pargstruct;
	HANDLE pjhtransportlayer;
	HANDLE phdl;
	HANDLE fd;
	unsigned char * pBuf;
	unsigned long size;
	int ret;
	JHZRESULT res;

	/* Create instance */
	res = JHCreateInst(&hdl, 0);
	if (JR_OK != res)
	{
		printf("\nFailure to JHCreateInst!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommInit();
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommInit!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

#if COMM_SERIALPORT
	res = JHCommGetTransportlayer(&pjhtransportlayer, DEV_SERIALPORT);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetTransportlayer!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommGetSerialportArgStruct(&pargstruct, "COM1", 115200, 8, 0, 0, 5000);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetSerialportArgStruct!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}
#else
	res = JHCommGetTransportlayer(&pjhtransportlayer, DEV_TCP);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetTransportlayer!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommGetNetArgStruct(&pargstruct, "192.168.1.3", 30000, 5000);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetNetArgStruct!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}
#endif

	JHMountTransportLayer(hdl, (JHTRANSPORTLAYER *)(pjhtransportlayer), (const void *)(pargstruct));
	JHCommReleaseArgStruct(pargstruct);

	/* Create batch file */
	JHCreateBatchFile1(&phdl, "1");
	if (NULL == phdl)
	{
		printf("\nFailure to create batch file !\n");
		JHDeleteInst(hdl);
		ret = -1;
		goto ERROR_OPERATION;
	}

	/* Add current lum instruction */
	res = JHSetCurLumIst(phdl, 0, 100);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		ret = -1;
		goto ERROR_OPERATION;
	}

	/* Add draw line instruction */
	res = JHDrawLineIst(phdl, 1, 0, 0, 0, 5);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		ret = -1;
		goto ERROR_OPERATION;
	}

	/* Get batch file size */
	res = JHGetBatchFileSize(phdl, &size);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		ret = -1;
		goto ERROR_OPERATION;
	}

	/* New resources of pBuf*/
	pBuf = (unsigned char *)calloc(1, size);

	/* Get batch file data */
	res = JHGetBatchFileData(phdl, pBuf);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		ret = -1;
		goto ERROR_OPERATION;
	}

	/* Create batch : three steps */

	/* the first step */
	res = JHPreCreateBatch(hdl, &fd, "1", size);
	if (JR_OK == res)
	{
		/* the second step */
		/* if size > 1024 , you need to use the for {;;} */
		res = JHWriteBatch(hdl, fd, 0, (const char *)pBuf, size);
		if (JR_OK == res)
		{
			printf("\nSuccessed in creating batch file!\n");
			ret = 0;
		}
		else
		{
			printf("\nFailure to create batch file!\n");
			ret = -1;
		}
	}
	else
	{
		printf("\nFailure to create batch file!\n");
	}

	/* the last step */
	res = JHFinCreateBatch(hdl, fd);

	/* Release resources of pBuf */
	free(pBuf);

	/* Delete batch file */
	JHDeleteBatchFile(phdl);

ERROR_OPERATION:
	JHCommDeinit();

	/* Delete instance */
	JHDeleteInst(hdl);

	system("pause");

	return ret;
}

