// SetLedModule.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>

#define __USER_STATIC_LIBRARY
#include "..\\..\\include\\JHComm.h"


#pragma comment (lib, "..\\..\\lib\\Windows\\jinhancomm.lib")
#pragma comment (lib, "..\\..\\lib\\Windows\\jinhanzk.lib")

#define COMM_SERIALPORT  1


int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hdl;
	HANDLE pargstruct;
	HANDLE pjhtransportlayer;
	int ret;
	JHZRESULT res;

	/* Create instance */
	res = JHCreateInst(&hdl, 0);
	if (JR_OK != res)
	{
		printf("\nFailure to JHCreateInst!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommInit();
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommInit!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

#if COMM_SERIALPORT
	res = JHCommGetTransportlayer(&pjhtransportlayer, DEV_SERIALPORT);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetTransportlayer!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommGetSerialportArgStruct(&pargstruct, "COM1", 115200, 8, 0, 0, 5000);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetSerialportArgStruct!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}
#else
	res = JHCommGetTransportlayer(&pjhtransportlayer, DEV_TCP);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetTransportlayer!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}

	res = JHCommGetNetArgStruct(&pargstruct, "192.168.1.3", 30000, 5000);
	if(JR_OK != res)
	{
		printf("\nFailure to JHCommGetNetArgStruct!\n");
		ret = -1;
		goto ERROR_OPERATION;
	}
#endif

	JHMountTransportLayer(hdl, (JHTRANSPORTLAYER *)(pjhtransportlayer), (const void *)(pargstruct));
	JHCommReleaseArgStruct(pargstruct);

	/* Set default ledmodule operation*/
	JHLEDMODULE JHLedModule;
	JHLedModule.lmScanDirection = 0;
	JHLedModule.lmColor = 0;
	JHLedModule.lmScan = 4;
	JHLedModule.lmOSR = 4;
	JHLedModule.lmOSC = 8;
	JHLedModule.lmRowDecode = 0;
	JHLedModule.lmPolar = 7;
	JHLedModule.lmClockPhase = 0;
	JHLedModule.lmLatchPhase = 0;
	JHLedModule.lmData = 0;
	JHLedModule.lmReserve[0] = 0;
	JHLedModule.lmReserve[1] = 0;
	JHLedModule.lmReserve[2] = 0;
	JHLedModule.lmReserve[3] = 0;
	JHLedModule.lmReserve[4] = 0;
	JHLedModule.lmReserve[5] = 0;
	JHLedModule.lmTrackMode = 1;
	JHLedModule.lmTrackSize = 0;

	unsigned char pTrack[512] = {0};

	res = JHSetDefLedMod(hdl, &JHLedModule, pTrack);
	if (JR_OK == res)
	{
		printf("\nSuccessed in setting default ledmodule!\n");
		ret = 0;
	}
	else
	{
		printf("\nFailure to set default ledmodule!\n");
		ret = -1;
	}

ERROR_OPERATION:
	JHCommDeinit();

	/* Delete instance */
	JHDeleteInst(hdl);

	system("pause");

	return ret;
}

