#ifdef _MSC_VER
/*
 * we do not want the warnings about the old deprecated and unsecure CRT functions
 * since these examples can be compiled under *nix as well
 */
#define _CRT_SECURE_NO_WARNINGS
#endif


#include "stdafx.h"
#include "JHComm.h"
#include "JHZk.h"


int main()
{
	HANDLE hdl;
	JHINFO_SERIALPORT JHInfo_serialport;
	HANDLE phdl;
	unsigned char * pBuf;
	unsigned long size;
	HANDLE fd;

	/* Create instance */
	JHCreateInst(&hdl, 0);
	if (NULL == hdl)
	{
		printf("\nFailure to create instance!\n");
		return -1;
	}

	/* Communication mode and parameters setting */
	JHInfo_serialport.size = sizeof(JHINFO_SERIALPORT);
	memcpy(JHInfo_serialport.serialport, "COM1", 5);
	JHInfo_serialport.baudrate = 115200;
	JHInfo_serialport.databits = 8;
	JHInfo_serialport.parity = 0;
	JHInfo_serialport.stopbits = 0;
	JHInfo_serialport.reserved = 0;
	JHInfo_serialport.timeout = 5000;
	JHMountTransportLayer(hdl, &JHTransportlayer_serialport, (const void *)(&JHInfo_serialport));

	/* Create batch file */
	JHCreateBatchFile1(&phdl, "1");
	if (NULL == phdl)
	{
		printf("\nFailure to create batch file !\n");
		JHDeleteInst(hdl);
		return -1;
	}

	/* Add current lum instruction */
	JHZRESULT res = JHSetCurLumIst(phdl, 0, 100);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		return -1;
	}

	/* Add draw line instruction */
	res = JHDrawLineIst(phdl, 1, 0, 0, 0, 5);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		return -1;
	}

	/* Get batch file size */
	res = JHGetBatchFileSize(phdl, &size);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		return -1;
	}

	/* New resources of pBuf*/
	pBuf = (unsigned char *)calloc(1, size);

	/* Get batch file data */
	res = JHGetBatchFileData(phdl, pBuf);
	if (JR_OK != res)
	{
		printf("\nFailure to create batch file!\n");
		JHDeleteBatchFile(phdl);
		JHDeleteInst(hdl);
		return -1;
	}

	/* Create batch : three steps */

	/* the first step */
	res = JHPreCreateBatch(hdl, &fd, "1", size);
	if (JR_OK == res)
	{
		/* the second step */
		/* if size > 1024 , you need to use the for {;;} */
		res = JHWriteBatch(hdl, fd, 0, (const char *)pBuf, size);
		if (JR_OK == res)
		{
			printf("\nSuccessed in creating batch file!\n");
		}
		else
		{
			printf("\nFailure to create batch file!\n");
		}
	}
	else
	{
		printf("\nFailure to create batch file!\n");
	}

	/* the last step */
	res = JHFinCreateBatch(hdl, fd);

	/* Release resources of pBuf */
	free(pBuf);

	/* Delete batch file */
	JHDeleteBatchFile(phdl);

	/* Delete instance */
	JHDeleteInst(hdl);

	Sleep(2000);

	return 0;
}


